#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
print "HTTP/1.0 200 OK\n";
print "content-type: application/x-javascript\n\n";
$sth=$dbh->query("LOCK TABLES rw_rings READ, rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT rid,rname FROM rw_rings,rw_users WHERE (status=1 AND rw_rings.uid=rw_users.uid) ORDER BY rname");
while (($rid,$rname)=$sth->fetchrow)
{
	$rname=~s/'/\\'/g;
	print qq~document.write(\'<option value="$rid">$rname</option>\');\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth="";
$dbh="";
