#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
sysread(STDIN,$data,$ENV{CONTENT_LENGTH});
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$data{$field}=$value;
	}
}

# Autorization
$sth=$dbh->query("LOCK TABLES rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid,acctype,status,email FROM rw_users WHERE (username='$data{name}' AND password='$data{password}')");
($uid,$type,$status,$email)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if (!$uid)
{
	push(@errors,"Incorrect username or password<br>");
	&error(@errors);
}
if (!$status)
{
	push(@errors,"Your account is not approved yet<br>");
	&error(@errors);
}
if ($status==2)
{
	push(@errors,"Your account is disabled<br>");
	&error(@errors);
}
$destination=$data{method};
&$destination if ($type==2);
push(@errors,"Wrong account type<br>");
&error(@errors);

sub chgenset
{
$data{desc}=~s/\r\n/\<br\>/g;
$data{desc}=~s/'/\\'/g;
$data{title}=~s/'/\\'/g;
$sth=$dbh->query("LOCK TABLES rw_sites WRITE") if ($locktables);
$sth=$dbh->query("UPDATE rw_sites SET sname='$data{title}',surl='$data{url}',sdescr='$data{desc}' WHERE uid=$uid");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES rw_sites READ") if ($locktables);
$sth=$dbh->query("SELECT sid,rid,sname,surl,sdescr,hits FROM rw_sites WHERE uid=$uid");
($sid,$rid,$titl,$uurl,$desc,$hits)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rname,hcode FROM rw_rings WHERE rid=$rid");
($fullrn,$htmlcode)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$desc=~s/\<br\>/\n/g;
$webring=$rid;
$user=$uid;
$selected[$status]="selected";
$htmlcode=~s/\~/\\\~/g;
eval "\$htmlcode=qq~$htmlcode~;";
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>CHANGE USERDATA</center></font></td></tr>
<tr><td width="100%"><font face="Arial" size="2"><form action="$cgi/rwuser.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="chgenset">
<input type="text" name="title" value="$titl" size=38 maxlength=100> - Title<br>
<input type="text" name="url" value="$uurl" size=38 maxlength=100> - URL<br>
<textarea name="desc" cols=30 rows=3>$desc</textarea> - Description<br>
<input type="Submit" value="Change data"><br></form></font></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>ACCOUNT STATUS</center></font></td></tr>
<tr><td width="100%"><font face="Arial" size="2"><form action="$cgi/rwuser.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="status">
<select name="status"><option value="1" $selected[1]>Enabled</option><option value="3" $selected[3]>Suspended</option></select><input type="Submit" value="Change status"><br></form></font></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>YOUR HTML CODE</center></font></td></tr>
<tr><td width="100%"><font face="Arial" size="2"><form><center><textarea cols=48 rows=10>&lt;!--Begin $title code--&gt;\n$htmlcode\n&lt;!--End $title code--&gt;</textarea></center></form></font></td></tr>
~;
&closedb;
open(F,"<$rwpath/template/user.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub status
{
if ($data{status}==1 || $data{status}==3)
{
$sth=$dbh->query("LOCK TABLES rw_users WRITE") if ($locktables);
$sth=$dbh->query("UPDATE rw_users SET status=$data{status} WHERE uid=$uid");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$status=$data{status};
}
$sth=$dbh->query("LOCK TABLES rw_sites READ") if ($locktables);
$sth=$dbh->query("SELECT sid,rid,sname,surl,sdescr,hits FROM rw_sites WHERE uid=$uid");
($sid,$rid,$titl,$uurl,$desc,$hits)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rname,hcode FROM rw_rings WHERE rid=$rid");
($fullrn,$htmlcode)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$desc=~s/\<br\>/\n/g;
$webring=$rid;
$user=$uid;
$selected[$status]="selected";
$htmlcode=~s/\~/\\\~/g;
eval "\$htmlcode=qq~$htmlcode~;";
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>CHANGE USERDATA</center></font></td></tr>
<tr><td width="100%"><font face="Arial" size="2"><form action="$cgi/rwuser.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="chgenset">
<input type="text" name="title" value="$titl" size=38 maxlength=100> - Title<br>
<input type="text" name="url" value="$uurl" size=38 maxlength=100> - URL<br>
<textarea name="desc" cols=30 rows=3>$desc</textarea> - Description<br>
<input type="Submit" value="Change data"><br></form></font></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>ACCOUNT STATUS</center></font></td></tr>
<tr><td width="100%"><font face="Arial" size="2"><form action="$cgi/rwuser.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="status">
<select name="status"><option value="1" $selected[1]>Enabled</option><option value="3" $selected[3]>Suspended</option></select><input type="Submit" value="Change status"><br></form></font></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>YOUR HTML CODE</center></font></td></tr>
<tr><td width="100%"><font face="Arial" size="2"><form><center><textarea cols=48 rows=10>&lt;!--Begin $title code--&gt;\n$htmlcode\n&lt;!--End $title code--&gt;</textarea></center></form></font></td></tr>
~;
&closedb;
open(F,"<$rwpath/template/user.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub error
{
@errors=@_;
&closedb;
open(F,"<$rwpath/template/error.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}	
sub closedb
{
$sth="";
$dbh="";
}
